/**
 Trivial Windows CreateThreads program.
 Orion Sky Lawlor, olawlor@acm.org, 2006/02/01 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h> /* for CreateThread */

enum {runTimes=20, delayLen=1*1000*1000};
int total=0;
volatile int doneCount=0; /* DANGEROUS exit flag */

volatile int i;
void *run(void *ptr) {
	int threadNo=*(int *)ptr;
	printf("Starting thread %d\n",threadNo);
	for (int n=0;n<runTimes;n++) {
		for (i=0;i<delayLen;i++) {}
		printf("%c: (it %d)  (total %d)\n",'A'+threadNo,n,total);
		total++;
	}
	doneCount++;
	return 0;
}

int main() {
	int count=0;
	for (int i=0;i<2;i++) {
		int *c=new int;
		*c=count; /* subtle: heap copy of count */
		DWORD threadId;
		HANDLE h=CreateThread(0,0,
			(LPTHREAD_START_ROUTINE)run,c,
			0,&threadId);
		count++;
	}
	//count=-1;
	//run(&count); /* so main runs too */
	printf("waiting for threads\n");
	while (doneCount!=2) {}
	printf("total is %d\n",total);
	return 0;
}
